## fluster 0.0~git20221018.187faa0ab8f0

=== Makefile ===
PY_FILES=fluster
CONTRIB_DIR=contrib
DECODERS_DIR=decoders
PYTHONPATH=.
FLUSTER=python3 ./fluster.py -tsd check
ifeq ($(OS),Windows_NT)
FLUSTER+=--no-emoji
else
KERNEL_NAME=$(shell uname -s)
endif

help:
	@awk -F ':|##' '/^[^\t].+?:.*?##/ { printf "\033[36m%-30s\033[0m %s\n", $$1, $$NF }' $(MAKEFILE_LIST)

install_deps: ## install Python dependencies
	python3 -m pip install -r requirements.txt

check: format-check lint ## check that very basic tests run
	@echo "Running dummy test..."
	$(FLUSTER) list
	$(FLUSTER) list -c
	$(FLUSTER) -ne list -c
	$(FLUSTER) list -ts dummy -tv
	$(FLUSTER) download dummy dummy_fail -k
	$(FLUSTER) run -ts dummy -tv one
	$(FLUSTER) reference Dummy dummy
	$(FLUSTER) run -ts dummy -tv one -j1
	$(FLUSTER) run -ts dummy -s
	$(FLUSTER) -ne run -ts dummy -s
	$(FLUSTER) run -ts dummy -so summary.log && cat summary.log && rm -rf summary.log
	$(FLUSTER) run -ts dummy -j1 -s
	$(FLUSTER) run -ts dummy -th 1
	$(FLUSTER) run -ts dummy -tth 10
ifneq ($(OS),Windows_NT)
	$(FLUSTER) run -ts dummy non_existing_test_suite; test $$? -ne 0
	$(FLUSTER) run -ts dummy -th 2; test $$? -eq 2
	$(FLUSTER) run -ts dummy -tth 0.000000001; test $$? -eq 3
	$(FLUSTER) run -ts dummy_fail -th 1
	$(FLUSTER) run -ts dummy_fail -th 2; test $$? -eq 2
	$(FLUSTER) run -ts dummy_fail -j1 -ff -s; test $$? -ne 0
	$(FLUSTER) download dummy non_existing_test_suite -k; test $$? -ne 0
	$(FLUSTER) download dummy dummy_download_fail -k; test $$? -ne 0
	$(FLUSTER) download H264-min H265-min VP8-min VP9-min -k
	$(FLUSTER) run -ts H264-min -d GStreamer-H.264-Libav-Gst1.0 FFmpeg-H.264 -s
	$(FLUSTER) run -ts H265-min -d GStreamer-H.265-Libav-Gst1.0 FFmpeg-H.265 -s
	$(FLUSTER) run -ts VP8-min -d libvpx-VP8 -s
	$(FLUSTER) run -ts VP9-min -d libvpx-VP9 -s
endif
	@echo "\nAll test finished succesfully!"

format: ## format Python code using black
	@echo "Formatting coding style with black..."
	black $(PY_FILES)

format-check:
	@echo "Checking coding style with black... Run '$(MAKE) format' to fix if needed"
	black --check $(PY_FILES)

lint: format-check ## run static analysis using pylint, flake8 and mypy
# ignore similar lines error: it's a bug when running parallel jobs - https://github.com/PyCQA/pylint/issues/4118
	@echo "Checking with pylint... "
	pylint $(PY_FILES) --fail-under=10
	@echo "Checking with flake8..."
	flake8 --max-line-length=120 $(PY_FILES)
	@echo "Checking with mypy..."
	mypy --strict $(PY_FILES)

create_dirs=mkdir -p $(CONTRIB_DIR) $(DECODERS_DIR)

all_reference_decoders: h265_reference_decoder h264_reference_decoder aac_reference_decoder ## build all reference decoders

h266_reference_decoder: ## build H.266 reference decoder
	$(create_dirs)
	cd $(CONTRIB_DIR) && git clone https://github.com/fraunhoferhhi/vvdec.git --depth=1 || true
	cd $(CONTRIB_DIR)/vvdec && git pull --autostash || true
	cd $(CONTRIB_DIR)/vvdec && cmake -H. -Bbuild -DCMAKE_BUILD_TYPE=Release -DCMAKE_C_FLAGS="-Wno-stringop-truncation -Wno-stringop-overflow" && $(MAKE) -C build vvdecapp
	find $(CONTRIB_DIR)/vvdec/bin/release-static/ -name "vvdecapp" -type f -exec cp {} $(DECODERS_DIR)/ \;

h265_reference_decoder: ## build H.265 reference decoder
	$(create_dirs)
	cd $(CONTRIB_DIR) && git clone https://vcgit.hhi.fraunhofer.de/jct-vc/HM.git --depth=1 || true
	cd $(CONTRIB_DIR)/HM && git stash && git pull && git stash apply || true
	cd $(CONTRIB_DIR)/HM && cmake -H. -Bbuild -DCMAKE_BUILD_TYPE=Release && $(MAKE) -C build TAppDecoder
	find $(CONTRIB_DIR)/HM/bin/umake -name "TAppDecoder" -type f -exec cp {} $(DECODERS_DIR)/ \;

h264_reference_decoder: ## build H.264 reference decoder
	$(create_dirs)
	cd $(CONTRIB_DIR) && git clone https://vcgit.hhi.fraunhofer.de/jct-vc/JM.git --depth=1 || true
	cd $(CONTRIB_DIR)/JM && git stash && git pull && git stash apply || true
	cd $(CONTRIB_DIR)/JM && cmake -H. -Bbuild -DCMAKE_BUILD_TYPE=Release -DCMAKE_C_FLAGS="-Wno-stringop-truncation -Wno-stringop-overflow" && $(MAKE) -C build ldecod
	find $(CONTRIB_DIR)/JM/bin/umake -name "ldecod" -type f -exec cp {} $(DECODERS_DIR)/ \;

aac_reference_decoder: ## build ISO MPEG4 AAC reference decoder
ifeq ($(dpkg -l | grep gcc-multilib), "")
	sudo apt-get install gcc-multilib
endif
ifeq ($(dpkg -l | grep g++-multilib), "")
	sudo apt-get install g++-multilib
endif

ifeq ($(wildcard $(CONTRIB_DIR)/C050470e_Electronic_inserts), )
	$(create_dirs)
	cd $(CONTRIB_DIR) && rm -f iso_cookies.txt
	cd $(CONTRIB_DIR) && wget -qO- --keep-session-cookies --save-cookies iso_cookies.txt \
	'https://standards.iso.org/ittf/PubliclyAvailableStandards/c050470__ISO_IEC_14496-5_2001_Amd_20_2009_Reference_Software.zip' > /dev/null
	cd $(CONTRIB_DIR) && wget --keep-session-cookies --load-cookies iso_cookies.txt --post-data 'ok=I+accept' \
	'https://standards.iso.org/ittf/PubliclyAvailableStandards/c050470__ISO_IEC_14496-5_2001_Amd_20_2009_Reference_Software.zip'
	cd $(CONTRIB_DIR) && unzip -q c050470__ISO_IEC_14496-5_2001_Amd_20_2009_Reference_Software.zip
	cd $(CONTRIB_DIR) && rm -f iso_cookies.txt c050470__ISO_IEC_14496-5_2001_Amd_20_2009_Reference_Software.zip

	cd $(CONTRIB_DIR) && git clone https://github.com/MPEGGroup/isobmff.git
	cd $(CONTRIB_DIR)/isobmff && mkdir build && cd build && cmake .. -DCMAKE_C_FLAGS=-m32 && $(MAKE) libisomediafile
	cd $(CONTRIB_DIR)/isobmff && mv lib/liblibisomediafile.a lib/libisomediafile.a
	cd $(CONTRIB_DIR) && cp isobmff/lib/libisomediafile.a C050470e_Electronic_inserts/audio/natural/import/lib/
	cd $(CONTRIB_DIR) && cp isobmff/IsoLib/libisomediafile/src/ISOMovies.h C050470e_Electronic_inserts/audio/natural/import/include/
	cd $(CONTRIB_DIR) && cp isobmff/IsoLib/libisomediafile/src/MP4Movies.h C050470e_Electronic_inserts/audio/natural/import/include/
ifeq ($(OS), Windows_NT)
	cd $(CONTRIB_DIR) && cp isobmff/IsoLib/libisomediafile/w32/MP4OSMacros.h C050470e_Electronic_inserts/audio/natural/import/include/
else ifeq ($(KERNEL_NAME), Linux)
	cd $(CONTRIB_DIR) && cp isobmff/IsoLib/libisomediafile/linux/MP4OSMacros.h C050470e_Electronic_inserts/audio/natural/import/include/ || true
else ifeq ($(KERNEL_NAME), Darwin)
	cd $(CONTRIB_DIR) && cp isobmff/IsoLib/libisomediafile/macosx/MP4OSMacros.h C050470e_Electronic_inserts/audio/natural/import/include/ || true
endif
	cd $(CONTRIB_DIR) && wget http://www-mmsp.ece.mcgill.ca/Documents/Downloads/libtsp/libtsp-v7r0.tar.gz
	cd $(CONTRIB_DIR) && tar -zxf libtsp-v7r0.tar.gz && chmod -R ugo=rwx libtsp-v7r0/ && cd libtsp-v7r0/ && $(MAKE) -s COPTS=-m32
	cd $(CONTRIB_DIR) && cp libtsp-v7r0/lib/libtsp.a C050470e_Electronic_inserts/audio/natural/import/lib/
	cd $(CONTRIB_DIR) && cp libtsp-v7r0/include/libtsp.h C050470e_Electronic_inserts/audio/natural/import/include/
	cd $(CONTRIB_DIR) && mkdir C050470e_Electronic_inserts/audio/natural/import/include/libtsp/
	cd $(CONTRIB_DIR) && cp libtsp-v7r0/include/libtsp/AFpar.h C050470e_Electronic_inserts/audio/natural/import/include/libtsp/
	cd $(CONTRIB_DIR) && cp libtsp-v7r0/include/libtsp/UTpar.h C050470e_Electronic_inserts/audio/natural/import/include/libtsp/
endif
	cd $(CONTRIB_DIR)/C050470e_Electronic_inserts/audio/natural/mp4mcDec && MAKELEVEL=0 $(MAKE) mp4audec_mc REFSOFT_INCLUDE_PATH=../import/include REFSOFT_LIBRARY_PATH=../import/lib CFLAGS=-m32 LDFLAGS=-m32
	find $(CONTRIB_DIR)/C050470e_Electronic_inserts/audio/natural/bin/mp4mcDec -name "mp4audec_mc" -type f -exec cp {} $(DECODERS_DIR) \;

clean: ## remove contrib temporary folder
	rm -rf $(CONTRIB_DIR)

dbg-%:
	echo "Value of $* = $($*)"

.PHONY: help all_reference_decoders h264_reference_decoder h265_reference_decoder aac_reference_decoder lint check format install_deps clean

=== requirements.txt ===
black
pylint==2.8.2
flake8
mypy

## fluster 0.0~git20221201.13b4e2990620

=== debian/changelog ===
fluster (0.0~git20221201.13b4e2990620-1) unstable; urgency=medium

  * New upstream version
  * Add salsa-ci file (routine-update)
  * Rebase patches onto new upstream release
  * Remove patches merged upstream
  * d/watch: Remove invalid tarball URL
  * d/copyright: Clarify project license

 -- Christopher Obbard <chris.obbard@collabora.com>  Thu, 08 Dec 2022 15:50:35 +0000

fluster (0.0~git20221018.187faa0ab8f0-1) unstable; urgency=medium

  * Initial release. (Closes: #1017438)
  * Improve d/copyright, thanks to ftpmasters.

 -- Christopher Obbard <chris.obbard@collabora.com>  Thu, 27 Oct 2022 15:37:14 +0100

=== debian/control ===
Source: fluster
Section: video
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders: Christopher Obbard <chris.obbard@collabora.com>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-python3,
 pybuild-plugin-pyproject,
 python3-all,
 python3-setuptools,
Standards-Version: 4.6.1
Homepage: https://github.com/fluendo/fluster
Vcs-Browser: https://salsa.debian.org/multimedia-team/fluster
Vcs-Git: https://salsa.debian.org/multimedia-team/fluster.git

Package: fluster
Architecture: all
Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends}
Description: Testing framework for multimedia decoder conformance
 Fluster is a testing framework written in Python for decoders conformance. It
 is composed of a CLI application that runs a number of test suites with the
 supported decoders. Its purpose is to check different decoder implementations
 against known test suites with known and tested results. It has been originally
 designed to check the conformance of H.265/HEVC decoders, but it also supports
 H.264/AVC and can be easily extended to add more decoders and test suites.
 .
 It is useful for codec development to ensure that the decoder driver and
 userspace components are implemented correctly.

=== debian/watch ===
version=4
opts="mode=git, pgpmode=none, pretty=0.0~git%cd.%h, repack, compression=xz" \
 https://github.com/fluendo/fluster.git \
 HEAD

## fluster 0.1.0

=== requirements.txt ===
black
pylint==2.13.9
flake8
mypy

=== debian/changelog ===
fluster (0.1.0-1) unstable; urgency=medium

  * Update d/watch to point at tagged releases
  * New upstream version
  * Standards-Version: 4.6.2 (routine-update)

 -- Christopher Obbard <chris.obbard@collabora.com>  Sun, 25 Dec 2022 10:53:41 +0000

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
  pybuild-plugin-pyproject,
  python3-all,
  python3-setuptools,
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Homepage: https://github.com/fluendo/fluster
 Vcs-Browser: https://salsa.debian.org/multimedia-team/fluster
 Vcs-Git: https://salsa.debian.org/multimedia-team/fluster.git

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export PYBUILD_NAME=fluster
export PYBUILD_SYSTEM=pyproject

%:
	dh $@ --with python3 --buildsystem=pybuild

=== debian/watch ===
version=4
opts="mode=git, pgpmode=none, pretty=0.1.0~git%cd.%h, repack, compression=xz" \
 https://github.com/fluendo/fluster.git \
 HEAD

opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/fluster-\$1\.tar\.gz/,\
uversionmangle=s/(\d)[_\.\-\+]?(RC|rc|pre|dev|beta|alpha)[.]?(\d*)$/\$1~\$2\$3/ \
  https://github.com/fluendo/fluster/tags .*/v?(\d\S*)\.tar\.gz

## fluster 1.0.1%2Bgit20231211.d9106f5

=== debian/watch ===
version=4
opts="mode=git, pgpmode=none, pretty=1.0.1+git%cd.%h, repack, compression=xz" \
 https://github.com/fluendo/fluster.git \
 HEAD

## fluster 1.0.1+git20230606.0c9a7db

=== debian/changelog ===
fluster (1.0.1+git20230606.0c9a7db-1) unstable; urgency=medium

  * d/watch: Remove watch line for tagged releases
  * d/watch: Bump version tag
  * New upstream version 1.0.1+git20230606.0c9a7db
  * Drop patches applied upstream
  * d/copyright: Bump date
  * Add patch to allow fluster to be ran from system directory
  * Add initial man page

 -- Christopher Obbard <chris.obbard@collabora.com>  Fri, 07 Jul 2023 16:41:55 +0100

=== debian/control ===
--- 
+++ 
@@ -7,6 +7,7 @@
 Build-Depends:
  debhelper-compat (= 13),
  dh-sequence-python3,
+ pandoc <!nodoc>,
  pybuild-plugin-pyproject,
  python3-all,
  python3-setuptools,

## fluster 1.0.1+git20231211.d9106f5

=== Makefile ===
--- 
+++ 
@@ -59,7 +59,7 @@
 lint: format-check ## run static analysis using pylint, flake8 and mypy
 # ignore similar lines error: it's a bug when running parallel jobs - https://github.com/PyCQA/pylint/issues/4118
 	@echo "Checking with pylint... "
-	pylint $(PY_FILES) --fail-under=10
+	pylint --fail-under=10.0 $(PY_FILES)
 	@echo "Checking with flake8..."
 	flake8 --max-line-length=120 $(PY_FILES)
 	@echo "Checking with mypy..."
@@ -67,7 +67,7 @@
 
 create_dirs=mkdir -p $(CONTRIB_DIR) $(DECODERS_DIR)
 
-all_reference_decoders: h265_reference_decoder h264_reference_decoder aac_reference_decoder ## build all reference decoders
+all_reference_decoders: h264_reference_decoder h265_reference_decoder h266_reference_decoder aac_reference_decoder ## build all reference decoders
 
 h266_reference_decoder: ## build H.266 reference decoder
 	$(create_dirs)
@@ -97,6 +97,11 @@
 ifeq ($(dpkg -l | grep g++-multilib), "")
 	sudo apt-get install g++-multilib
 endif
+ifeq ($(wildcard /usr/include/asm), )
+ifneq ($(wildcard /usr/include/asm-generic), )
+		sudo ln -s /usr/include/asm-generic /usr/include/asm
+endif
+endif
 
 ifeq ($(wildcard $(CONTRIB_DIR)/C050470e_Electronic_inserts), )
 	$(create_dirs)
@@ -121,8 +126,9 @@
 else ifeq ($(KERNEL_NAME), Darwin)
 	cd $(CONTRIB_DIR) && cp isobmff/IsoLib/libisomediafile/macosx/MP4OSMacros.h C050470e_Electronic_inserts/audio/natural/import/include/ || true
 endif
-	cd $(CONTRIB_DIR) && wget http://www-mmsp.ece.mcgill.ca/Documents/Downloads/libtsp/libtsp-v7r0.tar.gz
+	cd $(CONTRIB_DIR) && wget --no-check-certificate https://www-mmsp.ece.mcgill.ca/Documents/Downloads/libtsp/libtsp-v7r0.tar.gz
 	cd $(CONTRIB_DIR) && tar -zxf libtsp-v7r0.tar.gz && chmod -R ugo=rwx libtsp-v7r0/ && cd libtsp-v7r0/ && $(MAKE) -s COPTS=-m32
+	cd $(CONTRIB_DIR) && rm -f libtsp-v7r0.tar.gz
 	cd $(CONTRIB_DIR) && cp libtsp-v7r0/lib/libtsp.a C050470e_Electronic_inserts/audio/natural/import/lib/
 	cd $(CONTRIB_DIR) && cp libtsp-v7r0/include/libtsp.h C050470e_Electronic_inserts/audio/natural/import/include/
 	cd $(CONTRIB_DIR) && mkdir C050470e_Electronic_inserts/audio/natural/import/include/libtsp/
@@ -132,6 +138,12 @@
 	cd $(CONTRIB_DIR)/C050470e_Electronic_inserts/audio/natural/mp4mcDec && MAKELEVEL=0 $(MAKE) mp4audec_mc REFSOFT_INCLUDE_PATH=../import/include REFSOFT_LIBRARY_PATH=../import/lib CFLAGS=-m32 LDFLAGS=-m32
 	find $(CONTRIB_DIR)/C050470e_Electronic_inserts/audio/natural/bin/mp4mcDec -name "mp4audec_mc" -type f -exec cp {} $(DECODERS_DIR) \;
 
+ifneq ($(wildcard /usr/include/asm), )
+ifneq ($(wildcard /usr/include/asm-generic), )
+		sudo unlink /usr/include/asm
+endif
+endif
+
 clean: ## remove contrib temporary folder
 	rm -rf $(CONTRIB_DIR)

=== requirements.txt ===
black
pylint
flake8
mypy

=== debian/changelog ===
fluster (1.0.1+git20231211.d9106f5-1) unstable; urgency=medium

  * New upstream version 1.0.1+git20231211.d9106f5

 -- Christopher Obbard <obbardc@debian.org>  Wed, 10 Jan 2024 17:17:56 +0000

fluster (1.0.1+git20231127.9c70053-1) unstable; urgency=medium

  * New upstream version 1.0.1+git20231127.9c70053

 -- Christopher Obbard <obbardc@debian.org>  Tue, 28 Nov 2023 10:47:01 +0000

fluster (1.0.1+git20231126.2e8d5ab-1) unstable; urgency=medium

  * New upstream version 1.0.1+git20231126.2e8d5ab
  * Drop patches implemented upstream

 -- Christopher Obbard <obbardc@debian.org>  Mon, 27 Nov 2023 09:29:41 +0000

fluster (1.0.1+git20231107.590aad7-1) unstable; urgency=medium

  * New upstream version 1.0.1+git20231107.590aad7
  * Update my email address to obbardc@debian.org

 -- Christopher Obbard <obbardc@debian.org>  Sat, 18 Nov 2023 11:17:32 +0000

fluster (1.0.1+git20231003.303a6ed-1) unstable; urgency=medium

  * New upstream version 1.0.1+git20231003.303a6ed

 -- Christopher Obbard <chris.obbard@collabora.com>  Fri, 20 Oct 2023 15:17:51 +0100

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: video
 Priority: optional
 Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
-Uploaders: Christopher Obbard <chris.obbard@collabora.com>
+Uploaders: Christopher Obbard <obbardc@debian.org>
 Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (= 13),

=== debian/rules ===
--- 
+++ 
@@ -6,3 +6,9 @@
 
 %:
 	dh $@ --with python3 --buildsystem=pybuild
+
+ifeq (,$(filter nodoc,$(DEB_BUILD_PROFILES)))
+override_dh_auto_build:
+	pandoc debian/fluster.1.md -s -t man > debian/fluster.1
+	dh_auto_build
+endif

## fluster 1.0.1+really0.4.1

=== Makefile ===
CONTRIB_DIR=contrib
DECODERS_DIR=decoders
PYTHONPATH=.
FLUSTER=python3 ./fluster.py -tsd check
ifeq ($(OS),Windows_NT)
FLUSTER+=--no-emoji
else
KERNEL_NAME=$(shell uname -s)
endif
CMAKE_GENERATOR=Unix Makefiles

help:
	@awk -F ':|##' '/^[^\t].+?:.*?##/ { printf "\033[36m%-30s\033[0m %s\n", $$1, $$NF }' $(MAKEFILE_LIST)

install_deps: ## install Python dependencies
	python3 -m pip install -r requirements-dev.txt

check: ## check that very basic tests run
	@echo "Running dummy test..."
	$(FLUSTER) list
	$(FLUSTER) list -c
	$(FLUSTER) -ne list -c
	$(FLUSTER) list -ts dummy -tv
	$(FLUSTER) download dummy dummy_fail -k
	$(FLUSTER) run -ts dummy -tv one
	$(FLUSTER) reference Dummy dummy
	$(FLUSTER) run -ts dummy -tv one -j1
	$(FLUSTER) run -ts dummy -s
	$(FLUSTER) -ne run -ts dummy -s
	$(FLUSTER) run -ts dummy -so summary.log && cat summary.log && rm -rf summary.log
	$(FLUSTER) run -ts dummy -j1 -s
	$(FLUSTER) run -ts dummy -th 1
	$(FLUSTER) run -ts dummy -tth 10
ifneq ($(OS),Windows_NT)
	$(FLUSTER) run -ts dummy non_existing_test_suite; test $$? -ne 0
	$(FLUSTER) run -ts dummy -th 2; test $$? -eq 2
	$(FLUSTER) run -ts dummy -tth 0.000000001; test $$? -eq 3
	$(FLUSTER) run -ts dummy_fail -th 1
	$(FLUSTER) run -ts dummy_fail -th 2; test $$? -eq 2
	$(FLUSTER) run -ts dummy_fail -j1 -ff -s; test $$? -ne 0
	$(FLUSTER) download dummy non_existing_test_suite -k; test $$? -ne 0
	$(FLUSTER) download dummy dummy_download_fail -k; test $$? -ne 0
	$(FLUSTER) download H264-min H265-min -k
	$(FLUSTER) run -ts H264-min -d GStreamer-H.264-Libav-Gst1.0 FFmpeg-H.264 -s
	$(FLUSTER) run -ts H265-min -d GStreamer-H.265-Libav-Gst1.0 FFmpeg-H.265 -s
ifeq ($(KERNEL_NAME), Linux)
	$(FLUSTER) download AV1-min VP8-min VP9-min -k
	$(FLUSTER) run -ts AV1-min -d libaom-AV1 -s
	$(FLUSTER) run -ts VP8-min -d libvpx-VP8 -s
	$(FLUSTER) run -ts VP9-min -d libvpx-VP9 -s
endif
endif
	@echo "\nAll test finished succesfully!"

create_dirs=mkdir -p $(CONTRIB_DIR) $(DECODERS_DIR)

all_reference_decoders: h264_reference_decoder h265_reference_decoder h266_reference_decoder mpeg_2_aac_reference_decoder mpeg_4_aac_reference_decoder ## build all reference decoders

h266_reference_decoder: ## build H.266 reference decoder
	$(create_dirs)
	cd $(CONTRIB_DIR) && git clone https://vcgit.hhi.fraunhofer.de/jvet/VVCSoftware_VTM.git --depth=1 || true
	cd $(CONTRIB_DIR)/VVCSoftware_VTM && git pull --autostash || true
	cd $(CONTRIB_DIR)/VVCSoftware_VTM && mkdir -p build && cd build && cmake -DCMAKE_BUILD_TYPE=Release ..
	$(MAKE) -C $(CONTRIB_DIR)/VVCSoftware_VTM/build
	find $(CONTRIB_DIR)/VVCSoftware_VTM/bin/ -name "DecoderApp" -type f -exec cp {} $(DECODERS_DIR)/ \;

h266_vvdec_decoder: ## build H.266 VVdeC, the Fraunhofer Versatile Video Decoder
	$(create_dirs)
	cd $(CONTRIB_DIR) && git clone https://github.com/fraunhoferhhi/vvdec.git --depth=1 || true
	cd $(CONTRIB_DIR)/vvdec && git pull --autostash || true
	cd $(CONTRIB_DIR)/vvdec && cmake -H. -Bbuild -DCMAKE_BUILD_TYPE=Release -DCMAKE_C_FLAGS="-Wno-stringop-truncation -Wno-stringop-overflow" && $(MAKE) -C build vvdecapp
	find $(CONTRIB_DIR)/vvdec/bin/release-static/ -name "vvdecapp" -type f -exec cp {} $(DECODERS_DIR)/ \;

h265_reference_decoder: ## build H.265 reference decoder
	$(create_dirs)
	cd $(CONTRIB_DIR) && git clone https://vcgit.hhi.fraunhofer.de/jct-vc/HM.git --depth=1 || true
	cd $(CONTRIB_DIR)/HM && git stash && git pull && git stash apply || true
	cd $(CONTRIB_DIR)/HM && cmake -H. -Bbuild -DCMAKE_BUILD_TYPE=Release -DCMAKE_CXX_FLAGS="-Wno-array-bounds" && $(MAKE) -C build TAppDecoder
	find $(CONTRIB_DIR)/HM/bin/umake -name "TAppDecoder" -type f -exec cp {} $(DECODERS_DIR)/ \;

h264_reference_decoder: ## build H.264 reference decoder
	$(create_dirs)
	cd $(CONTRIB_DIR) && git clone https://vcgit.hhi.fraunhofer.de/jct-vc/JM.git --depth=1 || true
	cd $(CONTRIB_DIR)/JM && git stash && git pull && git stash apply || true
	cd $(CONTRIB_DIR)/JM && cmake -H. -Bbuild -DCMAKE_BUILD_TYPE=Release -DCMAKE_C_FLAGS="-Wno-stringop-truncation -Wno-stringop-overflow" && $(MAKE) -C build ldecod
	find $(CONTRIB_DIR)/JM/bin/umake -name "ldecod" -type f -exec cp {} $(DECODERS_DIR)/ \;

mpeg_2_aac_reference_decoder: ## build ISO MPEG2 AAC reference decoder
ifeq ($(KERNEL_NAME), Linux)
	if ! dpkg -l | grep gcc-multilib -c >>/dev/null; then sudo apt-get install gcc-multilib; fi
	if ! dpkg -l | grep g++-multilib -c >>/dev/null; then sudo apt-get install g++-multilib; fi
endif
	if [ ! $(wildcard /usr/include/asm) ] && [ $(wildcard /usr/include/asm-generic) ]; then sudo ln -s /usr/include/asm-generic /usr/include/asm; fi

ifeq ($(wildcard $(CONTRIB_DIR)/C039486_Electronic_inserts),)
	$(create_dirs)
	cd $(CONTRIB_DIR) && rm -f iso_cookies.txt
	cd $(CONTRIB_DIR) && wget -qO- --keep-session-cookies --save-cookies iso_cookies.txt \
	'https://standards.iso.org/ittf/PubliclyAvailableStandards/c039486_ISO_IEC_13818-5_2005_Reference_Software.zip' > /dev/null
	cd $(CONTRIB_DIR) && wget --keep-session-cookies --load-cookies iso_cookies.txt --post-data 'ok=I+accept' \
	'https://standards.iso.org/ittf/PubliclyAvailableStandards/c039486_ISO_IEC_13818-5_2005_Reference_Software.zip'
	cd $(CONTRIB_DIR) && unzip -oq c039486_ISO_IEC_13818-5_2005_Reference_Software.zip
	cd $(CONTRIB_DIR) && rm -f iso_cookies.txt c039486_ISO_IEC_13818-5_2005_Reference_Software.zip ipmp.zip mpeg2audio.zip systems.zip video.zip

	cd $(CONTRIB_DIR) && unzip -oq mpeg2aac.zip
	cd $(CONTRIB_DIR) && rm -f mpeg2aac.zip

	cd $(CONTRIB_DIR) && rm -rf isobmff && git clone https://github.com/MPEGGroup/isobmff.git
	cd $(CONTRIB_DIR)/isobmff && git checkout tags/v0.2.0 -b v0.2.0
	cd $(CONTRIB_DIR)/isobmff && mkdir -p build && cd build && cmake .. -DCMAKE_C_FLAGS=-m32 && $(MAKE) libisomediafile
	cd $(CONTRIB_DIR)/isobmff && mv lib/liblibisomediafile.a lib/libisomediafile.a
	cd $(CONTRIB_DIR) && cp isobmff/lib/libisomediafile.a mpeg2aac/import/lib/
	cd $(CONTRIB_DIR) && cp isobmff/IsoLib/libisomediafile/src/ISOMovies.h mpeg2aac/import/include/
	cd $(CONTRIB_DIR) && cp isobmff/IsoLib/libisomediafile/src/MP4Movies.h mpeg2aac/import/include/
ifeq ($(OS), Windows_NT)
	cd $(CONTRIB_DIR) && cp isobmff/IsoLib/libisomediafile/w32/MP4OSMacros.h mpeg2aac/import/include/
else ifeq ($(KERNEL_NAME), Linux)
	cd $(CONTRIB_DIR) && cp isobmff/IsoLib/libisomediafile/linux/MP4OSMacros.h mpeg2aac/import/include/ || true
else ifeq ($(KERNEL_NAME), Darwin)
	cd $(CONTRIB_DIR) && cp isobmff/IsoLib/libisomediafile/macosx/MP4OSMacros.h mpeg2aac/import/include/ || true
endif
	cd $(CONTRIB_DIR) && wget --no-check-certificate https://www-mmsp.ece.mcgill.ca/Documents/Downloads/libtsp/libtsp-v7r0.tar.gz
	cd $(CONTRIB_DIR) && tar -zxf libtsp-v7r0.tar.gz && chmod -R ugo=rwx libtsp-v7r0/ && cd libtsp-v7r0/ && $(MAKE) -s COPTS=-m32
	cd $(CONTRIB_DIR) && rm -f libtsp-v7r0.tar.gz
	cd $(CONTRIB_DIR) && cp libtsp-v7r0/lib/libtsp.a mpeg2aac/import/lib/
	cd $(CONTRIB_DIR) && cp libtsp-v7r0/include/libtsp.h mpeg2aac/import/include/
	cd $(CONTRIB_DIR) && mkdir -p mpeg2aac/import/include/libtsp/
	cd $(CONTRIB_DIR) && cp libtsp-v7r0/include/libtsp/AFpar.h mpeg2aac/import/include/libtsp/
	cd $(CONTRIB_DIR) && cp libtsp-v7r0/include/libtsp/UTpar.h mpeg2aac/import/include/libtsp/
endif
	cd $(CONTRIB_DIR)/mpeg2aac/aacDec && MAKELEVEL=0 $(MAKE) aacdec_mc REFSOFT_INCLUDE_PATH=../import/include REFSOFT_LIBRARY_PATH=../import/lib CFLAGS=-m32 LDFLAGS=-m32
	find $(CONTRIB_DIR)/mpeg2aac/bin/mp4mcDec -name "aacdec_mc" -type f -exec cp {} $(DECODERS_DIR) \;

	sudo rm -f /usr/include/asm

mpeg_2_video_reference_decoder: ## build ISO MPEG2 video reference decoder
ifeq ($(KERNEL_NAME), Linux)
	if ! dpkg -l | grep gcc-multilib -c >>/dev/null; then sudo apt-get install gcc-multilib; fi
	if ! dpkg -l | grep g++-multilib -c >>/dev/null; then sudo apt-get install g++-multilib; fi
endif
	if [ ! $(wildcard /usr/include/asm) ] && [ $(wildcard /usr/include/asm-generic) ]; then sudo ln -s /usr/include/asm-generic /usr/include/asm; fi

ifeq ($(wildcard $(CONTRIB_DIR)/C039486_Electronic_inserts),)
	$(create_dirs)
	cd $(CONTRIB_DIR) && rm -f iso_cookies.txt
	cd $(CONTRIB_DIR) && wget -qO- --keep-session-cookies --save-cookies iso_cookies.txt \
	'https://standards.iso.org/ittf/PubliclyAvailableStandards/c039486_ISO_IEC_13818-5_2005_Reference_Software.zip' > /dev/null
	cd $(CONTRIB_DIR) && wget --keep-session-cookies --load-cookies iso_cookies.txt --post-data 'ok=I+accept' \
	'https://standards.iso.org/ittf/PubliclyAvailableStandards/c039486_ISO_IEC_13818-5_2005_Reference_Software.zip'
	cd $(CONTRIB_DIR) && unzip -oq c039486_ISO_IEC_13818-5_2005_Reference_Software.zip
	cd $(CONTRIB_DIR) && rm -f iso_cookies.txt c039486_ISO_IEC_13818-5_2005_Reference_Software.zip ipmp.zip mpeg2audio.zip systems.zip mpeg2aac.zip

	cd $(CONTRIB_DIR) && unzip -oq video.zip
	cd $(CONTRIB_DIR) && rm -f video.zip
endif
	cd $(CONTRIB_DIR)/video/decoder && MAKELEVEL=0 $(MAKE) all
	find $(CONTRIB_DIR)/video/decoder -name "mpeg2decode" -type f -exec cp {} $(DECODERS_DIR) \;

	sudo rm -f /usr/include/asm

mpeg_4_aac_reference_decoder: ## build ISO MPEG4 AAC reference decoder
ifeq ($(KERNEL_NAME), Linux)
	if ! dpkg -l | grep gcc-multilib -c >>/dev/null; then sudo apt-get install gcc-multilib; fi
	if ! dpkg -l | grep g++-multilib -c >>/dev/null; then sudo apt-get install g++-multilib; fi
endif
	if [ ! $(wildcard /usr/include/asm) ] && [ $(wildcard /usr/include/asm-generic) ]; then sudo ln -s /usr/include/asm-generic /usr/include/asm; fi

ifeq ($(wildcard $(CONTRIB_DIR)/C050470e_Electronic_inserts), )
	$(create_dirs)
	cd $(CONTRIB_DIR) && rm -f iso_cookies.txt
	cd $(CONTRIB_DIR) && wget -qO- --keep-session-cookies --save-cookies iso_cookies.txt \
	'https://standards.iso.org/ittf/PubliclyAvailableStandards/c050470__ISO_IEC_14496-5_2001_Amd_20_2009_Reference_Software.zip' > /dev/null
	cd $(CONTRIB_DIR) && wget --keep-session-cookies --load-cookies iso_cookies.txt --post-data 'ok=I+accept' \
	'https://standards.iso.org/ittf/PubliclyAvailableStandards/c050470__ISO_IEC_14496-5_2001_Amd_20_2009_Reference_Software.zip'
	cd $(CONTRIB_DIR) && unzip -oq c050470__ISO_IEC_14496-5_2001_Amd_20_2009_Reference_Software.zip
	cd $(CONTRIB_DIR) && rm -f iso_cookies.txt c050470__ISO_IEC_14496-5_2001_Amd_20_2009_Reference_Software.zip

	cd $(CONTRIB_DIR) && rm -rf isobmff && git clone https://github.com/MPEGGroup/isobmff.git
	cd $(CONTRIB_DIR)/isobmff && git checkout tags/v0.2.0 -b v0.2.0
	cd $(CONTRIB_DIR)/isobmff && mkdir -p build && cd build && cmake .. -DCMAKE_C_FLAGS=-m32 && $(MAKE) libisomediafile
	cd $(CONTRIB_DIR)/isobmff && mv lib/liblibisomediafile.a lib/libisomediafile.a
	cd $(CONTRIB_DIR) && cp isobmff/lib/libisomediafile.a C050470e_Electronic_inserts/audio/natural/import/lib/
	cd $(CONTRIB_DIR) && cp isobmff/IsoLib/libisomediafile/src/ISOMovies.h C050470e_Electronic_inserts/audio/natural/import/include/
	cd $(CONTRIB_DIR) && cp isobmff/IsoLib/libisomediafile/src/MP4Movies.h C050470e_Electronic_inserts/audio/natural/import/include/
ifeq ($(OS), Windows_NT)
	cd $(CONTRIB_DIR) && cp isobmff/IsoLib/libisomediafile/w32/MP4OSMacros.h C050470e_Electronic_inserts/audio/natural/import/include/
else ifeq ($(KERNEL_NAME), Linux)
	cd $(CONTRIB_DIR) && cp isobmff/IsoLib/libisomediafile/linux/MP4OSMacros.h C050470e_Electronic_inserts/audio/natural/import/include/ || true
else ifeq ($(KERNEL_NAME), Darwin)
	cd $(CONTRIB_DIR) && cp isobmff/IsoLib/libisomediafile/macosx/MP4OSMacros.h C050470e_Electronic_inserts/audio/natural/import/include/ || true
endif
	cd $(CONTRIB_DIR) && wget --no-check-certificate https://www-mmsp.ece.mcgill.ca/Documents/Downloads/libtsp/libtsp-v7r0.tar.gz
	cd $(CONTRIB_DIR) && tar -zxf libtsp-v7r0.tar.gz && chmod -R ugo=rwx libtsp-v7r0/ && cd libtsp-v7r0/ && $(MAKE) -s COPTS=-m32
	cd $(CONTRIB_DIR) && rm -f libtsp-v7r0.tar.gz
	cd $(CONTRIB_DIR) && cp libtsp-v7r0/lib/libtsp.a C050470e_Electronic_inserts/audio/natural/import/lib/
	cd $(CONTRIB_DIR) && cp libtsp-v7r0/include/libtsp.h C050470e_Electronic_inserts/audio/natural/import/include/

=== debian/changelog ===
fluster (1.0.1+really0.4.1-1) unstable; urgency=medium

  * New upstream version 1.0.1+really0.4.1
  * d/salsa-ci.yml: Use latest include URL
  * d/control: Update Standards-Version to 4.7.2 (no changes)
  * d/watch: Use GitHub tags for upstream releases & use proper version

 -- Christopher Obbard <obbardc@debian.org>  Mon, 25 Aug 2025 22:09:04 +0100

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
  pybuild-plugin-pyproject,
  python3-all,
  python3-setuptools,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Homepage: https://github.com/fluendo/fluster
 Vcs-Browser: https://salsa.debian.org/multimedia-team/fluster
 Vcs-Git: https://salsa.debian.org/multimedia-team/fluster.git

=== debian/watch ===
version=4
opts="pgpmode=none, \
 uversionmangle=s/^(.*)$/1.0.1+really$1/" \
 https://github.com/fluendo/fluster/tags \
 .*/archive/refs/tags/v?(\d[\d\.]*)\.tar\.gz

## fluster 1.0.1+really0.6.0

=== debian/changelog ===
fluster (1.0.1+really0.6.0-2) unstable; urgency=medium

  * d/control: Bump Standards-Version to 4.7.3
  * d/control: Recommend decoder backends

 -- Christopher Obbard <obbardc@debian.org>  Wed, 31 Dec 2025 01:06:39 +0000

fluster (1.0.1+really0.6.0-1) unstable; urgency=medium

  * New upstream version 1.0.1+really0.6.0

 -- Christopher Obbard <obbardc@debian.org>  Sun, 14 Dec 2025 10:44:27 +0000

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: fluster
 Section: video
-Priority: optional
 Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders: Christopher Obbard <obbardc@debian.org>
 Rules-Requires-Root: no
@@ -11,7 +10,7 @@
  pybuild-plugin-pyproject,
  python3-all,
  python3-setuptools,
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Homepage: https://github.com/fluendo/fluster
 Vcs-Browser: https://salsa.debian.org/multimedia-team/fluster
 Vcs-Git: https://salsa.debian.org/multimedia-team/fluster.git
@@ -19,6 +18,14 @@
 Package: fluster
 Architecture: all
 Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends}
+Recommends:
+ ffmpeg,
+ gstreamer1.0-libav,
+ gstreamer1.0-plugins-bad,
+ gstreamer1.0-plugins-good,
+ gstreamer1.0-plugins-ugly,
+ gstreamer1.0-tools,
+ gstreamer1.0-vaapi,
 Description: Testing framework for multimedia decoder conformance
  Fluster is a testing framework written in Python for decoders conformance. It
  is composed of a CLI application that runs a number of test suites with the
